<template>
  <div>
    <div style="height: 12px" />
    <q-input :label="$t('invite_from_contacts.search_label')" filled v-model="searchQuery" />
    <div v-if="contactsFiltered && Object.keys(contactsFiltered).length"
      style="display: flex; margin-top: 12px; align-items: center">
      {{ $t("invite_from_contacts.invited") }}
      <q-space />
      <q-icon color="orange" name="star" style="margin-right:5px; font-size: 1em;">
      </q-icon>
      {{ $t("moderator") }}
      <q-icon name="help" class="q-ml-sm cursor-pointer" color="grey-9">
        <q-tooltip>
          <div class="text-body2">
            {{ $t("moderator_explanation") }}
          </div>
        </q-tooltip>
      </q-icon>
    </div>
    <div class="q-ma-lg" v-else>
      {{ 
        $t(Object.keys(this.contacts) > 0 ? "invite_from_contacts.no_contacts" : "invite_from_contacts.all_selected") 
      }}
    </div>
    <q-list separator style="margin-bottom:40px;">
      <q-item v-for="(contact, phoneNumber) in contactsFiltered" :key="phoneNumber" class="q-px-none" :clickable="canInvite" v-ripple
        @click.stop="() => handleRequestInvite(phoneNumber, contact, toInvite[phoneNumber] === undefined)">
        <q-item-section side>
          <q-checkbox :value="toInvite[phoneNumber] !== undefined" :disable="phoneNumber == hostNumber || !canInvite"
            @input="(newValue) => handleRequestInvite(phoneNumber, contact, newValue)" />
        </q-item-section>
        <q-item-section>
          <q-item-label>{{ contact.Name }}</q-item-label>
          <q-item-label caption>{{
              phoneNumber
          }}</q-item-label>
        </q-item-section>
        <q-item-section side>
          <q-checkbox :value="(toInvite[phoneNumber] || { Moderator: false }).Moderator"
            :disable="phoneNumber == hostNumber || !canInvite"
            @input="(newValue) => handleRequestModerator(phoneNumber, contact, newValue)" />
        </q-item-section>
      </q-item>
    </q-list>
  </div>
</template>

<script>
import Vue from "vue";

export default {
  props: {
    contacts: {
      required: true,
    },
    // This is the current contacts to invite
    toInvite: {
      required: true,
    },
    setToInvite: {
      required: true,
    },
    canInvite: {
      type: Boolean,
      default: true
    },
    hostNumber: {
      required: true
    },
    hideSelected: {
      required: false,
      type: Boolean,
      default: false
    }
  },
  data()
  {
    return {
      searchQuery: "",
    };
  },
  computed: {
    contactsFiltered()
    {
      if (this.contacts.loading) return {};

      let toFilter = this.contacts;

      if(this.hideSelected)
      {
        const invitedKeys = Object.keys(this.toInvite);
        toFilter = Object.keys(this.contacts)
          .filter( key => !invitedKeys.includes(key) )
          .reduce( (res, key) => (res[key] = this.contacts[key], res), {} );
      }

      return Object.fromEntries(
        (Object.entries(toFilter) || []).filter(([, contact]) => 
          contact.Name.toLowerCase().startsWith(this.searchQuery.toLowerCase())
        )
      );
    },
  },
  methods: {
    handleRequestInvite(phoneNumber, contact, newValue)
    {
      if(!this.canInvite) return;

      const currentToInvite = { ...(this.toInvite || {}) };
      if (newValue)
      {
        currentToInvite[phoneNumber] = {
          Name: contact.Name,
          Moderator: false,
        };
      } else
      {
        Vue.delete(currentToInvite, phoneNumber);
      }
      this.setToInvite(currentToInvite, phoneNumber, newValue);
    },
    handleRequestModerator(phoneNumber, contact, newValue)
    {
      const currentToInvite = { ...(this.toInvite || {}) };
      currentToInvite[phoneNumber] = {
        Name: contact.Name,
        Moderator: newValue,
      };
      this.setToInvite(currentToInvite);
    },
  },
};
</script>
